<?php
header('Content-Type: application/json');
header('Access-Control-Allow-Origin: *');
header('Access-Control-Allow-Methods: GET, POST');

$inactivityThreshold = 900; // 15 Minuten in Sekunden

// Benutzer aus Datei lesen und inaktive entfernen
$users = [];
$newUsers = [];
if (file_exists('user.txt')) {
    $file = fopen('user.txt', 'r');
    if (flock($file, LOCK_SH)) {
        $users = file('user.txt', FILE_IGNORE_NEW_LINES | FILE_SKIP_EMPTY_LINES);
        flock($file, LOCK_UN);
    }
    fclose($file);

    $currentTime = time();
    foreach ($users as $user) {
        list($id, $name, $timestamp) = explode('|', $user);
        if ($currentTime - $timestamp <= $inactivityThreshold) {
            $newUsers[] = $user;
        }
    }

    // Inaktive Benutzer entfernen, indem die Datei neu geschrieben wird
    $file = fopen('user.txt', 'w');
    flock($file, LOCK_EX);
    fwrite($file, implode("\n", $newUsers) . (empty($newUsers) ? '' : "\n"));
    flock($file, LOCK_UN);
    fclose($file);
}

// Timestamp des aktuellen Benutzers aktualisieren
if (isset($_POST['user_id']) && !empty($_POST['user_id'])) {
    $userId = $_POST['user_id'];
    $users = file_exists('user.txt') ? file('user.txt', FILE_IGNORE_NEW_LINES | FILE_SKIP_EMPTY_LINES) : [];
    $newUsers = [];
    foreach ($users as $user) {
        list($id, $name, $timestamp) = explode('|', $user);
        if ($id === $userId) {
            $newUsers[] = "$id|$name|" . time();
        } else {
            $newUsers[] = $user;
        }
    }
    $file = fopen('user.txt', 'w');
    flock($file, LOCK_EX);
    fwrite($file, implode("\n", $newUsers) . (empty($newUsers) ? '' : "\n"));
    flock($file, LOCK_UN);
    fclose($file);
}

// Benutzer für die Antwort vorbereiten
$userData = [];
foreach ($newUsers as $user) {
    list($id, $name, $timestamp) = explode('|', $user);
    $userData[] = ['id' => $id, 'name' => $name];
}

// JSON-Antwort senden
echo json_encode(['users' => $userData]);
?>
